#!/bin/bash

# This script retrieves sip and queue configuration using AMI and writes a file to be read by
# fucntions-custom-astdb.php in FOP2 Manager. Works well with Zycoo appliances

AMIUSER=admin
AMIPASS=amp111
AMIHOST=localhost

if [ -f /tmp/peers.txt ];
then
rm /tmp/peers.txt
fi

if [ -f /usr/local/fop2/ami_config.txt ];
then
rm /usr/local/fop2/ami_config.txt
fi

/usr/local/fop2/astcli -u $AMIUSER -s $AMIPASS -h $AMIHOST 'sip show peers' >/tmp/peers.txt
for A in `awk '{print $1}' /tmp/peers.txt | grep -v trunk | sed -e '1d;$d' | awk -F/ '{print $1}'`
do
    /usr/local/fop2/astcli -u $AMIUSER -s $AMIPASS -h $AMIHOST "sip show peer $A" | grep "\* Name\|Context\|Mailbox\|Caller" | sed 's/ \*//' | sed -E  's/\s+: /=/g' | sed -E 's/^\s+//g' >>/usr/local/fop2/ami_config.txt
    echo "Type=extension" >>/usr/local/fop2/ami_config.txt
    echo "" >>/usr/local/fop2/ami_config.txt
done
chown www-data.www-data /usr/local/fop2/ami_config.txt


for A in `awk '{print $1}' /tmp/peers.txt | grep trunk | awk -F/ '{print $1}'`
do
    echo "Name=$A" >>/usr/local/fop2/ami_config.txt
    echo "Type=trunk" >>/usr/local/fop2/ami_config.txt
    echo "" >>/usr/local/fop2/ami_config.txt
done

for A in `/usr/local/fop2/astcli -u $AMIUSER -s $AMIPASS -h $AMIHOST 'queue show' | grep strategy | awk '{print $1}'`
do
    echo "Name=$A" >>/usr/local/fop2/ami_config.txt
    echo "Type=queue" >>/usr/local/fop2/ami_config.txt
    echo "" >>/usr/local/fop2/ami_config.txt
done

